Std Group
|
Menu location |
---|
Tree view → Right click on the document name → Create group |
Workbenches |
All |
Default shortcut |
None |
Introduced in version |
- |
See also |
Std Part, Draft SelectGroup, Draft AddToGroup |
Description
Std Group (internally called App DocumentObjectGroup) is a general purpose container that allows you to group different types of objects in the Tree view, regardless of their data type. It is used as a simple folder to categorize and organize the objects in your model, in order to keep a logical structure. Std Groups may be nested inside other Std Groups.
The Std Group tool is not defined by a particular workbench, but by the base system, thus it is found in the structure toolbar that is available in all workbenches.
To group 3D objects as a single unit, with the intention of creating assemblies, use Std Part instead.
Various elements inside Std Groups in the tree view.
Usage
- Do one of the following:
- Right-click the name of the document in the Tree view and in the context menu choose Create group....
- Press the
Create group button.
- An empty Group is created.
- To add objects to the Group, select them in Tree view, and drag and drop them onto the Group.
- To remove objects from the Group, drag them out of the Group, and onto the document label at the top of the Tree view.
- Objects can also be added and removed by editing the DataGroup property of the Group.
Properties
The Std Group, internally called App DocumentObjectGroup (App::DocumentObjectGroup
class), is derived from the basic App DocumentObject (App::DocumentObject
class) and inherits all its properties.
The Std Group has the same properties as the App FeaturePython, which is the most basic instance of an App DocumentObject. It also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.
Data
Base
- DataGroup (
LinkList
): a list of referenced objects. By default, it is empty[]
. - Data (Hidden)_ Group Touched (
Bool
): whether the group is touched or not.
Scripting
See also: FreeCAD Scripting Basics and scripted objects.
See Part Feature for the general information on adding objects to the document.
A Std Group (App DocumentObjectGroup) is created with the addObject()
method of the document. Once a Group exists, other objects can be added to it with the addObject()
or addObjects()
methods.
import FreeCAD as App
doc = App.newDocument()
group = App.ActiveDocument.addObject("App::DocumentObjectGroup", "Group")
obj1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj2 = App.ActiveDocument.addObject("Part::Box", "Box")
group.addObjects([obj1, obj2])
App.ActiveDocument.recompute()
This basic App::DocumentObjectGroup
doesn't have a Proxy object so it can't be fully used for sub-classing.
For Python subclassing you should create a App::DocumentObjectGroupPython
object.
import FreeCAD as App
doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::DocumentObjectGroupPython", "Name")
obj.Label = "Custom label"
For example, a FEM Analysis is an App::DocumentObjectGroupPython
object with a custom icon and additional properties.
Links
- File: New, Open, Open Recent, Close, Close All, Save, Save As, Save a Copy, Save All, Revert, Import, Export,Merge project, Document information, Print, Print preview, Export PDF, Exit
- Edit: Undo, Redo, Cut, Copy, Paste, Duplicate selection, Refresh, Box selection, Box element selection, Select All, Delete, Send to Python Console, Placement, Transform, Alignment, Toggle Edit mode, Properties, Edit mode, Preferences
- View:
- Miscellaneous: Create new view, Orthographic view, Perspective view, Fullscreen, Bounding box, Toggle axis cross, Clipping plane, Persistent section cut, Texture mapping, Toggle navigation/Edit mode, Material, Appearance, Random color, Color per face, Toggle transparency, Workbench, Status bar
- Standard views: Fit all, Fit selection, Align to selection, Isometric, Dimetric, Trimetric, Home, Front, Top, Right, Rear, Bottom, Left, Rotate Left, Rotate Right, Store working view, Recall working view
- Freeze display: Save views, Load views, Freeze view, Clear views
- Draw style: As is, Points, Wireframe, Hidden line, No shading, Shaded, Flat lines
- Stereo: Stereo red/cyan, Stereo quad buffer, Stereo Interleaved Rows, Stereo Interleaved Columns, Stereo Off, Issue camera position
- Zoom: Zoom In, Zoom Out, Box zoom
- Document window: Docked, Undocked, Fullscreen
- Visibility: Toggle visibility, Show selection, Hide selection, Select visible objects, Toggle all objects, Show all objects, Hide all objects, Toggle selectability
- Toolbars: File, Edit, Clipboard, Workbench, Macro, View, Individual views, Structure, Help, Lock toolbars
- Panels: Tree view, Property view, Model, Selection view, Python console, Report view, Tasks, DAG view
- Dock window overlay: Toggle overlay for all, Toggle transparent for all, Toggle overlay, Toggle transparent, Bypass mouse events in docked overlay windows, Toggle left, Toggle right, Toggle top, Toggle bottom
- Link navigation: Go to linked object, Go to the deepest linked object, Select all links
- Tree view actions: Sync view, Sync selection, Sync placement, Pre-selection, Record selection, Single document, Multi document, Collapse/Expand, Initiate dragging, Go to selection, Selection back, Selection forward
- Tools: Edit parameters, Save image, Load image, Scene inspector, Dependency graph, Export dependency graph, Document utility, Add text document, View turntable, Units converter, Customize, Addon manager, Measure
- Macro: Macro recording, Macros, Recent macros, Execute macro, Attach to remote debugger, Debug macro, Stop debugging, Step over, Step into, Toggle breakpoint
- Help: Help, FreeCAD Website, Donate, Users documentation, Python scripting documentation, Automatic Python modules documentation, FreeCAD Forum, FreeCAD FAQ, Report a bug, About FreeCAD, What's This, Start
- Additional:
- Miscellaneous: Create part, Create group, Make link, Make sub-link, Replace with link, Unlink, Import links, Import all links, Make link group, Create a variable set, Select all instances, Toggle freeze
- Expression actions: Copy selected, Copy active document, Copy all documents, Paste
- Selection filter: Vertex selection, Edge selection, Face selection, All selection filters cleared

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub